/**
 * @brief Implementation of startup system task.
 *
 * Define STA_OS2_STARTUP_ENABLE in <sta/config.hpp> to enable.
 *
 * Configuration:
 *     STA_OS2_STARTUP_ENTRY_FUNCTION:  Name of task entry function (default: startupTask)
 */
#ifndef STA_OS2_STARTUP_HPP
#define STA_OS2_STARTUP_HPP

#include <sta/config.hpp>
#ifdef STA_OS2_STARTUP_ENABLE


namespace sta
{
	/**
	 * @brief Extra initialization run at start of startup task.
	 *
	 * May be overridden by application if required.
	 */
	void startupExtras(void * argument);
} // namespace sta


#endif // STA_OS2_STARTUP_ENABLE

#endif // STA_OS2_STARTUP_HPP
