#include <sta/os2/signal.hpp>


namespace sta
{
	Os2Signal::Os2Signal(osSemaphoreId_t * semaphore)
		: semaphore_{semaphore}
	{}

	void Os2Signal::notify()
	{
		osSemaphoreRelease(*semaphore_);
	}

	bool Os2Signal::peek()
	{
		return (osSemaphoreGetCount(*semaphore_) != 0);
	}

	bool Os2Signal::test()
	{
		return (osSemaphoreAcquire(*semaphore_, 0) == osOK);
	}

	void Os2Signal::wait()
	{
		osSemaphoreAcquire(*semaphore_, osWaitForever);
	}
} // namespace sta
